;restore,'3C286_sp_RcvrPF_1_0.6_0_09Jan22_07:38:41.sav', /ve

sigmalimit=3.0
restore,/ve,'coeffs_out_3C286_839MHz_22Jan2009.sav'
mm_tot= coeffs_out.m_tot
mm_tel_iau= fltarr(4,4)
for ndiag=0,3 do mm_tel_iau[ndiag, ndiag]=1.0

;print,'1',mm_tot
;s_meas= fltarr, src= [coeffs_out.stki_uncal, 

;create_muellerparams_carl, muellerparams1
a= {srcname:sourcename, scan:0, cfr:freq}
windownr= 9
if n_elements( ps1yes) eq 0 then ps1yes=0

;GENERATE THE MUELLER MATRIX FILE NAME...
caldat, mjd2jd( src[0].mjdstart), month, day, year
muellerfilename= 'coeffs_out_' + sourcename+ '_' + $
strtrim(string(freq/1.e6, format='(i)'),1) + 'MHz_' $
+ string( day, format='(i2.2)') + monthnr2monthname(month)+ $
strtrim(year,1)+ '.sav'

;SET TO MAKE A SAVE FILE...
mueller_save=0 +1

products_to_stokes_2021, gainchnls, cal_indx, cts_per_k_xx, cts_per_k_yy, $
            phase_zero, phase_slope, freq_rf, $
            xx10, xx00, yy10, yy00, $
            xy10, xy00, yx10, yx00, $
            stki_meas, stkq_meas, stku_meas, stkv_meas, $
            xxcalib, yycalib, xycalib, yxcalib, $
            no_intensitycal=no_intensitycal, mean_med_off=mean_med_off

sz= size( stki_meas)
nrchnls= sz[ 1]
nrpos= sz[ 2]
stk_meas= fltarr( nrchnls, 4, nrpos)
for npos=0, nrpos-1 do begin
   stk_meas[ *, 0, npos]= stki_meas[ *, npos]
   stk_meas[ *, 1, npos]= stkq_meas[ *, npos]
   stk_meas[ *, 2, npos]= stku_meas[ *, npos]
   stk_meas[ *, 3, npos]= stkv_meas[ *, npos]
endfor

;stop
;AVERAGE OVER CHANNELS...
stki_meas_cont= total( stki_meas, 1)/nrchnls
stkq_meas_cont= total( stkq_meas, 1)/nrchnls
stku_meas_cont= total( stku_meas, 1)/nrchnls
stkv_meas_cont= total( stkv_meas, 1)/nrchnls

;CONVERT TO FRACTIONAL STOKES PARAMS...DIVIDE BY STOKES I
stkq_meas_cont_norm= stkq_meas_cont/ stki_meas_cont
stku_meas_cont_norm= stku_meas_cont/ stki_meas_cont
stkv_meas_cont_norm= stkv_meas_cont/ stki_meas_cont
stki_meas_cont_norm= stki_meas_cont/ stki_meas_cont

mm_coeffs_in_setup, coeffs_in

;#######################
;TURN THE MEASURED STOKES PARAMS INTO MUELLER-CALIBRATED ONES (TO
;TEST THE RESULTS)

if keyword_set(muellerchk) then begin
   mueller_save=0
   print, 'muellerchk=1. Setting mueller_save=0'
   stokesmeas= fltarr( 1, 4, nrpos)
   stokesmeas[ 0, 0,*]= stki_meas_cont_norm
   stokesmeas[ 0, 1,*]= stkq_meas_cont_norm
   stokesmeas[ 0, 2,*]= stku_meas_cont_norm
   stokesmeas[ 0, 3,*]= stkv_meas_cont_norm

   m_rho_x=1 *0
   m_tel_iau=0
   cfr=8.395e8

   mmcorr, mm_tot, m_astron, parallactic_on, stokesmeas, stokescal, $
        m_rho_x=m_rho_x, m_tel_iau=m_tel_iau
   stki_cal_cont_norm= stokescal[ 0,0,*]
   stkq_cal_cont_norm= stokescal[ 0,1,*]
   stku_cal_cont_norm= stokescal[ 0,2,*]
   stkv_cal_cont_norm= stokescal[ 0,3,*]

   onoffs_to_pacoeffs, $
        parallactic_on, stki_cal_cont_norm, stkq_cal_cont_norm, $
        stku_cal_cont_norm, stkv_cal_cont_norm, sigmalimit, $
        pacoeffs, ngoodpoints=ngoodpoints
pacoeffs_plt=pacoeffs
stki_plt= stki_cal_cont_norm
stkq_plt= stkq_cal_cont_norm
stku_plt= stku_cal_cont_norm
stkv_plt= stkv_cal_cont_norm

   coeffs_in.src= '3C286-CAL, ' + strtrim( long( freq/1.e6),2) + ' MHz'
endif else begin                ;#######################
   onoffs_to_pacoeffs, $
        parallactic_on, stki_meas_cont_norm, stkq_meas_cont_norm, $
        stku_meas_cont_norm, stkv_meas_cont_norm, sigmalimit, $
        pacoeffs, ngoodpoints=ngoodpoints
pacoeffs_plt=pacoeffs
stki_plt= stki_meas_cont_norm
stkq_plt= stkq_meas_cont_norm
stku_plt= stku_meas_cont_norm
stkv_plt= stkv_meas_cont_norm
   coeffs_in.src= '3C286-MEAS, ' + strtrim( long( freq/1.e6),2) + ' MHz'
endelse

;
mmfit_2016, pacoeffs, coeffs_in, coeffs_out, sigcoeffs_out, /fixvsrc, $
        nloop=nloop ;, ncov=ncov, noprint=noprint, tdata=tdata, tfit=tfit, $
;        m_tot=m_tot, pacoeffs_out=pacoeffs_out, problem=problem

if keyword_set( mueller_save) then $
   save, coeffs_out, sigcoeffs_out, file=muellerfilename

;PRINT ON THE TERMINAL WINDOW...
nrps=0
indx=0
;print_stokespa, indx, a, muellerparams1, ngoodpoints, nloop
print_stokespa_2021, indx, a, coeffs_out, sigcoeffs_out, ngoodpoints, nloop

;PLOT AND PRINT THE RESULTS ON X PLOTTING WINDOW
;prtplot, nrps, windownr, indx, a, muellerparams1, $
prtplot_2021, nrps, windownr, indx, a, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_plt, stkq_plt, $
   stku_plt, stkv_plt, $
        pacoeffs_plt, ngoodpoints, $
         title=title

;PLOT AND PRINT THE RESULTS ON PS FILE IF SO DESIRED...
if ( ps1yes eq 1) then begin
nrps=1
prtplot_2021, nrps, windownr, indx, a, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_plt, stkq_plt, $
   stku_plt, stkv_plt, $
        pacoeffs_plt, ngoodpoints, $
        title=title, path=outpath, plotfilename=plotfilename
endif

end
