;INITIALIZE PARAMETERS...
sigmalimit=6.0
sigmalimit= 3.0

;create_muellerparams_carl, muellerparams1
a= {srcname:sourcename, scan:0, cfr:freq}
windownr= 9
;if n_elements( ps1yes) eq 0 then ps1yes=0

;GENERATE THE MUELLER MATRIX FILE NAME...
caldat, mjd2jd( src[0].mjdstart), month, day, year
muellerfilename= 'coeffs_out_' + sourcename+ '_' + $
strtrim(string(freq/1.e6, format='(i)'),1) + 'MHz_' $
+ string( day, format='(i2.2)') + monthnr2monthname(month)+ $
strtrim(year,1)+ '.sav'

;SET TO MAKE A SAVE FILE...
mueller_save=0 ;;+1
if mueller_save eq 1 then stop, '>>>> YOU ARE SETTING MUELLER_SAVE. DO YOU REALLY WANT TO DO THIS???'

;if the mueller file already exists, read it to get current version of
;coeffs_out.
fileinfo= FILE_INFO( muellerfilename)
if fileinfo.exists eq 1 then begin
   restore, muellerfilename
   print, '>>>> NOTE !!! <<<<<'
   print, '>>>> READING COEFFS_OUT FROM ' + MUELLERFILENAME
ENDIF

products_to_stokes_2021, gainchnls, cal_indx, cts_per_k_xx, cts_per_k_yy, $
            phase_zero, phase_slope, freq_rf, $
            xx10, xx00, yy10, yy00, $
            xy10, xy00, yx10, yx00, $
            stki_uncal, stkq_uncal, stku_uncal, stkv_uncal, $
            xxcalib, yycalib, xycalib, yxcalib, $
            no_intensitycal=no_intensitycal, mean_med_off=mean_med_off

;stop
;AVERAGE OVER CHANNELS...
stki_uncal_cont= total( stki_uncal, 1)/nchnls
stkq_uncal_cont= total( stkq_uncal, 1)/nchnls
stku_uncal_cont= total( stku_uncal, 1)/nchnls
stkv_uncal_cont= total( stkv_uncal, 1)/nchnls

;NORMALIZE...DIVIDE BY SOURCE STOKES I
stkq_uncal_cont_norm= stkq_uncal_cont/ stki_uncal_cont
stku_uncal_cont_norm= stku_uncal_cont/ stki_uncal_cont
stkv_uncal_cont_norm= stkv_uncal_cont/ stki_uncal_cont
stki_uncal_cont_norm= stki_uncal_cont/ stki_uncal_cont

stokes_uncal= [[stki_uncal_cont_norm], $
[stkq_uncal_cont_norm], $
[stku_uncal_cont_norm], $
[stkv_uncal_cont_norm]]

;#######################
;TURN THE UNCALIBRATED STOKES PARAMS INTO MUELLER-CALIBRATED ONES (TO
;TEST THE RESULTS)
if n_elements( muellerchk) eq 0 then muellerchk=0
if (muellerchk gt 0) then begin
   mueller_save=0
   print, 'Setting mueller_save=0; muellerchk= ', strtrim(muellerchk, 2)
   stokesuncal= fltarr( 1, 4, n_elements( stki_uncal_cont_norm))
   stokesuncal[ 0,0,*]= stki_uncal_cont_norm
   stokesuncal[ 0,1,*]= stkq_uncal_cont_norm
   stokesuncal[ 0,2,*]= stku_uncal_cont_norm
   stokesuncal[ 0,3,*]= stkv_uncal_cont_norm

   m_rho_x=0
   if muellerchk eq 2 then m_rho_x=1
   m_tel_iau=0
   cfr=8.395e8
   mm_rx= coeffs_out.m_tot
;   rcvrfile_3C286_839MHz_22Jan2009, cfr, m_tot, m_astron
   mmcorr, mm_rx, mm_tel_iau, parallactic_on, stokesuncal, stokescal, $
        m_rho_x=m_rho_x, m_tel_iau= m_tel_iau
   stki_uncal_cont_norm= stokescal[ 0,0,*]
   stkq_uncal_cont_norm= stokescal[ 0,1,*]
   stku_uncal_cont_norm= stokescal[ 0,2,*]
   stkv_uncal_cont_norm= stokescal[ 0,3,*]
endif
;#######################

onoffs_to_pacoeffs, $
        parallactic_on, stki_uncal_cont_norm, stkq_uncal_cont_norm, $
        stku_uncal_cont_norm, stkv_uncal_cont_norm, sigmalimit, $
        pacoeffs, ngoodpoints=ngoodpoints

mm_coeffs_in_setup, coeffs_in
coeffs_in.src= '3C286, ' + strtrim( long( freq/1.e6),2) + ' MHz'
;mmfit_2016, pacoeffs, coeffs_in, coeffs_out, sigcoeffs_out, /fixvsrc, $
;        nloop=nloop ;, ncov=ncov, noprint=noprint, tdata=tdata, tfit=tfit, $
;;        m_tot=m_tot, pacoeffs_out=pacoeffs_out, problem=problem

mmfit_2016_chisq, pacoeffs, coeffs_in, coeffs_out, sigcoeffs_out, $
        chisq_full=chisq_full, chisq_red=chisq_red, $
        /fixvsrc, nloop=nloop, /dochisq

if keyword_set( mueller_save) then $
   save, coeffs_out, sigcoeffs_out, file=muellerfilename

;PRINT ON THE TERMINAL WINDOW...
nrps=0
indx=0
;print_stokespa, indx, a, muellerparams1, ngoodpoints, nloop
print_stokespa_2021, indx, a, coeffs_out, sigcoeffs_out, ngoodpoints, nloop
title= a.srcname + '_FREQ_' + $
strtrim( long(string(a.cfr/1.e6)), 2) + '_' + strtrim( muellerchk, 2) + $
       '_chisqfit

;PLOT AND PRINT THE RESULTS ON X PLOTTING WINDOW
;prtplot, nrps, windownr, indx, a, muellerparams1, $
prtplot_2021, nrps, windownr, indx, a, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_uncal_cont_norm, stkq_uncal_cont_norm, $
   stku_uncal_cont_norm, stkv_uncal_cont_norm, $
        pacoeffs, ngoodpoints, $
         title=title

;PLOT AND PRINT THE RESULTS ON PS FILE IF SO DESIRED...
if keyword_set( ps1yes) then begin
nrps=1
prtplot_2021, nrps, windownr, indx, a, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_uncal_cont_norm, stkq_uncal_cont_norm, $
   stku_uncal_cont_norm, stkv_uncal_cont_norm, $
        pacoeffs, ngoodpoints, $
        title=title, path=outpath, plotfilename=title 
endif

end
