
;WE FIND THE INDICES FOR WHICH WE ARE ONSRC OR OFFSRC WITH CAL OFF
;ndx00 is indices of off source, off cal
;ndx10 is indices of on source, off cal
;ndx01 is indices of off source, on cal
;ndx11 is indices of on source, on cal 
;the cal is always off for these src data, so no ndx01, indx11

sz= size( src.subscan)

ndx00_src= where( strmatch( src.sname, '*off') eq 1, nrndx00_src)
ndx10_src= where( strmatch( src.sname, '*off') eq 0, nrndx10_src)

on= reform( src[ ndx10_src].subscan, sz[1]*nrndx10_src)
parallactic_on= parangle( 15.d0*on.lst- on.cra2000, on.cdec2000, src[0].antlat, /degree)
mjdrel_on= on.mjd- src[0].subscan[0].mjd

off= reform( src[ ndx00_src].subscan, sz[1]*nrndx00_src)
parallactic_off= parangle( 15.d0*off.lst- off.cra2000, off.cdec2000, src[0].antlat, /degree)
mjdrel_off= off.mjd- src[0].subscan[0].mjd

;DEFINE THE ON-SOURCE AND OFF-SOURCE PRODUCT SPECTRA...
nroff= n_elements( off)
nron= n_elements( on)
offoff= reform( off.spec)
onoff=  reform( on.spec)

xx00= reform( offoff[ *, 0, *])
xy00= reform( offoff[ *, 1, *])
yy00= reform( offoff[ *, 2, *])
yx00= reform( offoff[ *, 3, *])
xx10= reform( onoff[ *, 0, *])
xy10= reform( onoff[ *, 1, *])
yy10= reform( onoff[ *, 2, *])
yx10= reform( onoff[ *, 3, *])

;SELECT THE CAL INDEX FOR EACH SOURCE INDEX...  
; We balanced, took a CALOFF/ON, 
; Then we took 4 scans of ONSRC/OFFSRC/ONSRC/OFFSRC.
; So we go through all of the ON/OFF-SOURCE spectra and apply the
; PREVIOUS gain measurement...
; That is, we want to select the cal that was IMMEDIATELY PRIOR to the FIRST
; ON-SOURCE SUBSCAN time for a given scan..
ontime = on.mjd
cal_indx= lonarr( nron)
  
;for nr= n_elements( caltime)- 1, 0l, -1l do begin
for nr= 0l, n_elements( caltime)- 1l, 1l do begin
      indx= where( caltime[nr] lt ontime, nrindx)
      if nrindx ne 0 then cal_indx[ indx]= nr
;     print,nr, nrindx
   endfor

end

